Debian Bug report logs - #706974
ITP: assword -- Simple and secure password management and retrieval system.

version graph

Package: wnpp; Maintainer for wnpp is wnpp@debian.org;

Reported by: Jameson Graef Rollins <jrollins@finestructure.net>

Date: Mon, 6 May 2013 15:45:01 UTC

Owned by: Jameson Graef Rollins <jrollins@finestructure.net>

Severity: wishlist

Fixed in version assword/0.7-1

Done: Jameson Rollins <jrollins@finestructure.net>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, debian-devel@lists.debian.org, dkg@fifthhorseman.net, wnpp@debian.org:
Bug#706974; Package wnpp. (Mon, 06 May 2013 15:45:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jameson Graef Rollins <jrollins@finestructure.net>:
New Bug report received and forwarded. Copy sent to debian-devel@lists.debian.org, dkg@fifthhorseman.net, wnpp@debian.org. (Mon, 06 May 2013 15:45:06 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Jameson Graef Rollins <jrollins@finestructure.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: ITP: assword -- Simple and secure password management and retrieval system.
Date: Mon, 06 May 2013 08:34:00 -0700
Package: wnpp
Severity: wishlist
Owner: Jameson Graef Rollins <jrollins@finestructure.net>

-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

* Package name    : assword
  Version         : 0.7
  Upstream Author : Jameson Graef Rollins <jrollins@finestructure.net>
* URL             : http://finestructure.net/assword/
* License         : GPL
  Programming Lang: Python
  Description     : Simple and secure password management and retrieval system.

Passwords and context strings are stored in a single OpenPGP encrypted
and signed file.  The contexts can be searched.  Passwords are
securely retrieved without displaying on the screen.  Multiple
retrieval methods are available, including inserting retrieved
password into the X clipboard, or typing them directly into an X
window.

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJRh81mAAoJEO00zqvie6q8o7oQALsCWM++BMC/6K203TfM/mN+
C7QbnfnRg74TzISdQs/cBlf3KEW3rN6rg72LITPTXOvxDh3fgk/7mHSJRbVP5qcL
bMNucb38uhCN5jBG+1O9C5v952jwIiqd0EX2g7AOMLVQRr+0R+jPTSCg8VvfX2gY
xdE+VOeV1YO1V3w4DeQGFphCshXlDZBdT63ydFhxPXGfG4G6UzkrD3HTIAbNUjrn
4KZF6Us2YpMcmEk8ROlY/LNM8ZXZYgvx7M08N865ifVH9mXEmTcYe2v/2W8D6cPm
LSpcL2b8mybF804r8qvXutacXVtO5+VsXd9ZtnfvGAv9Z6dFdw/v8Ai33hVs0Ppc
CZBoNPebTiyMzATWhrdcEmiKHBSufTVVNIJ06Q2kOO05tbwk8D589walrl+nWJaw
l93BW89i/TKBeHgJaTYhJddixPtD5xgox5frHLBs9Aju8r+05+cqSDeq3KOxCLj8
j8GwylxXhCewFkDV7gXJJZcdNaewTuleE/f2ztB3aykI10e/nev8JMe7XE8AZgXg
BlmYlha880bpYP1VrnBJB/uq4ZDM0PQeBrihXTrJPzEKzwlq+3WMR2QBYHeHl6Up
4hyZZTo+ME+9beqTrEVm4dZmAjJRCaR7fjjqm0JDTCr/Dss0sYNK24pMOf8gVLSL
St50QLuAsof88KIGDTRq
=rj9J
-----END PGP SIGNATURE-----



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>:
Bug#706974; Package wnpp. (Mon, 06 May 2013 16:00:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>. (Mon, 06 May 2013 16:00:04 GMT) Full text and rfc822 format available.

Message #10 received at 706974@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 706974@bugs.debian.org
Subject: Re: Bug#706974: ITP: assword -- Simple and secure password management and retrieval system.
Date: Mon, 06 May 2013 17:58:38 +0200
Quoting Jameson Graef Rollins (2013-05-06 17:34:00)
> * Package name    : assword
>   Version         : 0.7
>   Upstream Author : Jameson Graef Rollins <jrollins@finestructure.net>
> * URL             : http://finestructure.net/assword/
> * License         : GPL
>   Programming Lang: Python
>   Description     : Simple and secure password management and retrieval system.
> 
> Passwords and context strings are stored in a single OpenPGP encrypted
> and signed file.  The contexts can be searched.  Passwords are
> securely retrieved without displaying on the screen.  Multiple
> retrieval methods are available, including inserting retrieved
> password into the X clipboard, or typing them directly into an X
> window.

How is this different from pass?

 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#706974; Package wnpp. (Mon, 06 May 2013 16:33:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jameson Graef Rollins <jrollins@finestructure.net>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Mon, 06 May 2013 16:33:04 GMT) Full text and rfc822 format available.

Message #15 received at 706974@bugs.debian.org (full text, mbox):

From: Jameson Graef Rollins <jrollins@finestructure.net>
To: Jonas Smedegaard <dr@jones.dk>, 706974@bugs.debian.org, 706974@bugs.debian.org
Subject: Re: Bug#706974: ITP: assword -- Simple and secure password management and retrieval system.
Date: Mon, 06 May 2013 09:20:04 -0700
[Message part 1 (text/plain, inline)]
On Mon, May 06 2013, Jonas Smedegaard <dr@jones.dk> wrote:
> Quoting Jameson Graef Rollins (2013-05-06 17:34:00)
>> * Package name    : assword
>>   Version         : 0.7
>>   Upstream Author : Jameson Graef Rollins <jrollins@finestructure.net>
>> * URL             : http://finestructure.net/assword/
>> * License         : GPL
>>   Programming Lang: Python
>>   Description     : Simple and secure password management and retrieval system.
>> 
>> Passwords and context strings are stored in a single OpenPGP encrypted
>> and signed file.  The contexts can be searched.  Passwords are
>> securely retrieved without displaying on the screen.  Multiple
>> retrieval methods are available, including inserting retrieved
>> password into the X clipboard, or typing them directly into an X
>> window.
>
> How is this different from pass?

It's similar, but it 

 * doesn't use git
 * doesn't expose password contexts to the local disk
 * much smaller and lighter weight
 * uses gpgme bindings instead of exec'ing gpg

Probably most importantly, Assword has an X integration feature that
types passwords directly into windows without exposing them to the
screen or to the clipboard.

jamie.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>:
Bug#706974; Package wnpp. (Mon, 06 May 2013 16:45:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>. (Mon, 06 May 2013 16:45:07 GMT) Full text and rfc822 format available.

Message #20 received at 706974@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 706974@bugs.debian.org
Subject: Re: Bug#706974: ITP: assword -- Simple and secure password management and retrieval system.
Date: Mon, 06 May 2013 18:42:24 +0200
Quoting Jameson Graef Rollins (2013-05-06 18:20:04)
> On Mon, May 06 2013, Jonas Smedegaard <dr@jones.dk> wrote:
> > Quoting Jameson Graef Rollins (2013-05-06 17:34:00)
> >> * Package name    : assword
> >>   Version         : 0.7
> >>   Upstream Author : Jameson Graef Rollins <jrollins@finestructure.net>
> >> * URL             : http://finestructure.net/assword/
> >> * License         : GPL
> >>   Programming Lang: Python
> >>   Description     : Simple and secure password management and retrieval system.
> >> 
> >> Passwords and context strings are stored in a single OpenPGP encrypted
> >> and signed file.  The contexts can be searched.  Passwords are
> >> securely retrieved without displaying on the screen.  Multiple
> >> retrieval methods are available, including inserting retrieved
> >> password into the X clipboard, or typing them directly into an X
> >> window.
> >
> > How is this different from pass?
> 
> It's similar, but it 
> 
>  * doesn't use git
>  * doesn't expose password contexts to the local disk
>  * much smaller and lighter weight
>  * uses gpgme bindings instead of exec'ing gpg
> 
> Probably most importantly, Assword has an X integration feature that
> types passwords directly into windows without exposing them to the
> screen or to the clipboard.

Thanks for the clarification.

Perhaps others will wonder similarly: I suggest mention that additional 
info in long description.


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#706974; Package wnpp. (Mon, 06 May 2013 17:03:10 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jameson Graef Rollins <jrollins@finestructure.net>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Mon, 06 May 2013 17:03:10 GMT) Full text and rfc822 format available.

Message #25 received at 706974@bugs.debian.org (full text, mbox):

From: Jameson Graef Rollins <jrollins@finestructure.net>
To: Jonas Smedegaard <dr@jones.dk>, 706974@bugs.debian.org, 706974@bugs.debian.org
Cc: Daniel Kahn Gillmor <dkg@fifthhorseman.net>
Subject: Re: Bug#706974: ITP: assword -- Simple and secure password management and retrieval system.
Date: Mon, 06 May 2013 10:01:37 -0700
[Message part 1 (text/plain, inline)]
On Mon, May 06 2013, Jonas Smedegaard <dr@jones.dk> wrote:
> Perhaps others will wonder similarly: I suggest mention that additional 
> info in long description.

Thanks for the feedback, Jonas.

I would rather not start enumerating how it's different than specific
other password management systems, though.  Is there something specific
that you think is worth calling out in the description?

jamie.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>:
Bug#706974; Package wnpp. (Tue, 07 May 2013 07:39:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>. (Tue, 07 May 2013 07:39:07 GMT) Full text and rfc822 format available.

Message #30 received at 706974@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 706974@bugs.debian.org
Subject: Re: Bug#706974: ITP: assword -- Simple and secure password management and retrieval system.
Date: Tue, 07 May 2013 09:36:55 +0200
Quoting Jameson Graef Rollins (2013-05-06 19:01:37)
> On Mon, May 06 2013, Jonas Smedegaard <dr@jones.dk> wrote:
> > Perhaps others will wonder similarly: I suggest mention that 
> > additional info in long description.
> 
> Thanks for the feedback, Jonas.
> 
> I would rather not start enumerating how it's different than specific 
> other password management systems, though.  Is there something 
> specific that you think is worth calling out in the description?

I don't know the tool so have no specifics to share.

My point was and is that when reading your proposed long description it 
does not help me in deciding if that package is relevant for me, when 
compared against "pass" which I am familiar with - which is the very 
purpose of long description field.

(might very well be that the long description of "pass" and other 
packages could need some improvement too, but that is a separate issue).


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private



Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org:
Bug#706974; Package wnpp. (Tue, 07 May 2013 15:57:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jameson Graef Rollins <jrollins@finestructure.net>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org. (Tue, 07 May 2013 15:57:04 GMT) Full text and rfc822 format available.

Message #35 received at 706974@bugs.debian.org (full text, mbox):

From: Jameson Graef Rollins <jrollins@finestructure.net>
To: Jonas Smedegaard <dr@jones.dk>, 706974@bugs.debian.org
Subject: Re: Bug#706974: ITP: assword -- Simple and secure password management and retrieval system.
Date: Tue, 07 May 2013 08:55:03 -0700
[Message part 1 (text/plain, inline)]
On Tue, May 07 2013, Jonas Smedegaard <dr@jones.dk> wrote:
> I don't know the tool so have no specifics to share.
>
> My point was and is that when reading your proposed long description it 
> does not help me in deciding if that package is relevant for me, when 
> compared against "pass" which I am familiar with - which is the very 
> purpose of long description field.
>
> (might very well be that the long description of "pass" and other 
> packages could need some improvement too, but that is a separate issue).

Thanks, Jonas.  I expanded the description a bit, so hopefully that will
help clarify.

jamie.

Description: Simple and secure password management and retrieval system.
 Assword is a secure password manager that relies on your OpenPGP key
 for security and is designed to integrate in a minimal fashion into
 any X11 window manager.
 .
 Passwords and context strings are stored in a single
 OpenPGP-encrypted and signed file (meaning entry contexts are not
 exposed to the filesystem).  Along with a simple command-line
 interface, there is a streamlined GUI meant for X11 window manager
 integration.  When invoked, the GUI produces a prompt to search
 stored contexts.  New entries can also easily be created.  Passwords
 are securely retrieved without displaying on the screen.  Multiple
 retrieval methods are available, including auto-typing them directly
 into an X11 window (default), or inserting them into the X11 clipboard.
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>:
Bug#706974; Package wnpp. (Tue, 07 May 2013 16:15:11 GMT) Full text and rfc822 format available.

Acknowledgement sent to Jonas Smedegaard <dr@jones.dk>:
Extra info received and forwarded to list. Copy sent to wnpp@debian.org, Jameson Graef Rollins <jrollins@finestructure.net>. (Tue, 07 May 2013 16:15:11 GMT) Full text and rfc822 format available.

Message #40 received at 706974@bugs.debian.org (full text, mbox):

From: Jonas Smedegaard <dr@jones.dk>
To: 706974@bugs.debian.org
Subject: Re: Bug#706974: ITP: assword -- Simple and secure password management and retrieval system.
Date: Tue, 07 May 2013 18:13:43 +0200
Quoting Jameson Graef Rollins (2013-05-07 17:55:03)
> On Tue, May 07 2013, Jonas Smedegaard <dr@jones.dk> wrote:
> > I don't know the tool so have no specifics to share.
> >
> > My point was and is that when reading your proposed long description 
> > it does not help me in deciding if that package is relevant for me, 
> > when compared against "pass" which I am familiar with - which is the 
> > very purpose of long description field.
> >
> > (might very well be that the long description of "pass" and other 
> > packages could need some improvement too, but that is a separate 
> > issue).
> 
> Thanks, Jonas.  I expanded the description a bit, so hopefully that 
> will help clarify.
> 
> jamie.
> 
> Description: Simple and secure password management and retrieval system.
>  Assword is a secure password manager that relies on your OpenPGP key
>  for security and is designed to integrate in a minimal fashion into
>  any X11 window manager.
>  .
>  Passwords and context strings are stored in a single
>  OpenPGP-encrypted and signed file (meaning entry contexts are not
>  exposed to the filesystem).  Along with a simple command-line
>  interface, there is a streamlined GUI meant for X11 window manager
>  integration.  When invoked, the GUI produces a prompt to search
>  stored contexts.  New entries can also easily be created.  Passwords
>  are securely retrieved without displaying on the screen.  Multiple
>  retrieval methods are available, including auto-typing them directly
>  into an X11 window (default), or inserting them into the X11 clipboard.

Great!

Makes me wanna install it! :-D


 - Jonas

-- 
 * Jonas Smedegaard - idealist & Internet-arkitekt
 * Tlf.: +45 40843136  Website: http://dr.jones.dk/

 [x] quote me freely  [ ] ask before reusing  [ ] keep private



Added tag(s) pending. Request was from Anibal Monsalve Salazar <anibal@debian.org> to control@bugs.debian.org. (Tue, 07 May 2013 20:06:04 GMT) Full text and rfc822 format available.

Reply sent to Jameson Rollins <jrollins@finestructure.net>:
You have taken responsibility. (Thu, 16 May 2013 13:04:27 GMT) Full text and rfc822 format available.

Notification sent to Jameson Graef Rollins <jrollins@finestructure.net>:
Bug acknowledged by developer. (Thu, 16 May 2013 13:04:27 GMT) Full text and rfc822 format available.

Message #47 received at 706974-close@bugs.debian.org (full text, mbox):

From: Jameson Rollins <jrollins@finestructure.net>
To: 706974-close@bugs.debian.org
Subject: Bug#706974: fixed in assword 0.7-1
Date: Thu, 16 May 2013 13:00:18 +0000
Source: assword
Source-Version: 0.7-1

We believe that the bug you reported is fixed in the latest version of
assword, which is due to be installed in the Debian FTP archive.

A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 706974@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Jameson Rollins <jrollins@finestructure.net> (supplier of updated assword package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA512

Format: 1.8
Date: Tue, 07 May 2013 08:57:17 -0700
Source: assword
Binary: assword
Architecture: source all
Version: 0.7-1
Distribution: unstable
Urgency: low
Maintainer: Jameson Rollins <jrollins@finestructure.net>
Changed-By: Jameson Rollins <jrollins@finestructure.net>
Description: 
 assword    - Simple and secure password management and retrieval system.
Closes: 706974
Changes: 
 assword (0.7-1) unstable; urgency=low
 .
   [ Daniel Kahn Gillmor ]
   * New Upstream Version
   * fix "Create" from xsearch
   * clean up/sync documentation now that numeric id's are not used.
 .
   [ Jameson Rollins ]
   * fix debian dependencies and recommends
   * Closes ITP bug with wnpp (Closes: #706974)
Checksums-Sha1: 
 02f0611647fcff716a69105af9718bdc863d6523 1988 assword_0.7-1.dsc
 9d4c4bc7bcc413a1840fb7c5f5050be485444e3b 8444 assword_0.7.orig.tar.gz
 78fbda7f50cc30f68109a67715b909f21fdc534c 2173 assword_0.7-1.debian.tar.gz
 0c10dfbaff557b9a42c62f3aafde4944264d2fd7 9946 assword_0.7-1_all.deb
Checksums-Sha256: 
 b1416e219b392d929b2699cb7013ab87415e338609f77a528aca8b34027b456c 1988 assword_0.7-1.dsc
 95f19830cd8d6c3bef8cb86f38ccb595930a05ddf5ecefd93aa3681a595350b6 8444 assword_0.7.orig.tar.gz
 a47bd3d09c44e5cd232e95973834568e7f1b724499af6df1280458ddaebb2729 2173 assword_0.7-1.debian.tar.gz
 d0fee8815ed90a2d65717ef5b7bff724f6a6290e9c18cf106ca9df04c3a531d0 9946 assword_0.7-1_all.deb
Files: 
 f314131b55f956fdc0e66e91266f5008 1988 python optional assword_0.7-1.dsc
 c6ced2ab640fe347af025e3968b227bf 8444 python optional assword_0.7.orig.tar.gz
 c395487e40fc21b8b8a9b267638765d6 2173 python optional assword_0.7-1.debian.tar.gz
 f74d2619def3b5ad66ce501bc66ca775 9946 python optional assword_0.7-1_all.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQJ8BAEBCgBmBQJRiTZIXxSAAAAAAC4AKGlzc3Vlci1mcHJAbm90YXRpb25zLm9w
ZW5wZ3AuZmlmdGhob3JzZW1hbi5uZXRFQjk2OTEyODdBN0FEREUzNzU3RDkxMUVB
NTI0MDFCMTFCRkRGQTVDAAoJEKUkAbEb/fpc4cYQALYwSQaisJBLddlqWyno1a5D
PsA3sRx8bkGLY+H7VXLQg81d2eDgtCQ5btUgu/m/YQw5I6kNeeEcXB4MAteDa4t2
5Jj4o8h37RekcWv8HFr5sipCJT3lQYMCtA6SlTtsYA67I2BAUfewUG3FqaZAKjw/
e3UjW9xFCgt+CZwQAd5WAtUBXNNCu48629iF+VOAC3tF1hgGayf+8epnwWVDNL9m
4T3lm+mGlQMAs9I0wsS9+p/rSeHV0Fs9solAxNH/BgS+cBveepi5RjGXsmTtZxbH
Y56t/wbecoopazsa11ZNP8QAfacsW3RbF27T3LkMbbEpis7vnrvTwUE1Irv5cGNd
D2UIVgvZBX8b7fomYjv/m4zHqc3rGEzavIuOS9R98vfZeXoG1YdP8jt7gE6w8XRb
nkZtL4eH3BVQslqYEWBlxCtkiE23YR+naDk4QZ5C6YxbXQ1zNRs3lKH3tL2Zme7s
yKFrDCiaWvkvei/MkNfTwE+WXjgbzZjPB/UDBCsJLT80WKW1Y3U89fcfDi7Qnbs3
fke6Br29slukGPfMXAu80P2SW8cc0Rj02h4OwSASKjiYUMgeC6S6VYr9mA49j7Gd
4DBYTEq3T5h1EDPUNF6uSuZFEI5bD2PIgX/sg+i2WQhF64HjteMgqvEybtsw8dBn
1r3LSbTI0YtUrDkuSIm5
=6QAL
-----END PGP SIGNATURE-----




Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 14 Jun 2013 08:02:24 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 00:48:22 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.